/* eslint-disable no-param-reassign */
module.exports = {
  columns: [
    // pivots
    {
      data: 'rollup_name',
      export: true,
      id: 'rollup_id',
      kind: 'pivot',
      searchable: true,
    },
    {
      data: 'geography_name',
      export: true,
      id: 'geography_id',
      kind: 'pivot',
      searchable: true,
    },
    {
      base: true,
      data: 'name',
      export: true,
      id: 'media_id',
      kind: 'pivot',
      searchable: true,
    },
    // values
    {
      data: 'plan_spend',
      export: true,
      kind: 'value',
      reducer: 'sum',
    },
    {
      data: 'opt_spend',
      export: true,
      kind: 'value',
      reducer: 'sum',
    },
    {
      data: 'override_impact',
      export: true,
      kind: 'value',
      reducer: 'mean',
    },
    // derived
    // first order
    {
      data: 'spend_difference',
      derive: aggregate => aggregate.opt_spend - aggregate.plan_spend,
      export: true,
      kind: 'derived',
      order: 1,
    },
    // second order
    {
      data: 'spend_difference_per_impact',
      derive: aggregate => aggregate.spend_difference / aggregate.override_impact,
      export: true,
      kind: 'derived',
      order: 2,
    },
  ],
  postProcessing: {
    createRowData(x) {
      x.postProcessing = true;
    },
    initialize(x) {
      x.postProcessing = true;
    },
    summarizeAggregate(x) {
      x.postProcessing = true;
    },
  },
  subTable: {
    data: 'creative',
    columns: [
      {
        data: 'mct_name',
        kind: 'pivot',
      },
      {
        data: 'opt_spend',
        kind: 'value',
        reducer: 'sum',
      },
      {
        data: 'mct_name_opt_spend',
        derive: aggregate => `${aggregate.mct_name}_${aggregate.opt_spend}`,
        kind: 'derived',
        order: 1,
        reducer: 'sum',
      },
    ],
  },
  options: {
    paging: {},
  },
};
